#pragma once

template <class T, int A>
class MallocList
{
	enum {
		MAX_ARRAY = A.
	};

protected:
	size_t m_index;
	T *m_data[ MAX_ARRAY ];

	void safeRel_release( int i )
	{
		if (NULL == m_data[ i ]) {
			return;
		}
		delete m_data[i];
		m_data[i] = NULL;
	}

public:
	explicit MallocList() : m_index(0)
	{
		for (int i = 0; i < MAX_ARRAY; ++i) {
			m_data[i] = NULL;
		}
	}

	virtual ~MallocList()
	{
		for (int i = 0; i < MAX_ARRAY; ++i) {
			safe_release( m_data[i] );
		}
	}

	void push_back( T &p )
	{
		m_data[m_index] = new T;
		*m_data[m_index] = p;
		++m_index;
	}

	void erase( size_t x )
	{
		delete m_data[ x ];
		for (int i = x; i < MAX_ARRAY - 1; ++i) {
			m_data[ i ] = m_data[ i + 1 ];
		}
		--m_index;
	}

	T& operator[](size_t i)
	{
		return &m_data[i];
	}

	size_t size()
	{
		return m_index;
	}

};

#include "plugindata.h"
extern std::vector<PluginData> PluginList;

#include "resource.h"

extern HINSTANCE hDllInst;
extern boost::mutex mutex;

#define CHANNEL_AUDIO_BUFF 20000
#define MAX_INOUT_CHANNEL 8

class VSTProcessingWait
{
private:
	volatile unsigned char m_ref;
public:
	explicit VSTProcessingWait() : m_ref(0)
	{

	}

	virtual ~VSTProcessingWait()
	{

	}

	void lock()
	{
		if (m_ref == 0) {
			m_ref++;
		}else{
			unsigned long lockSessionTimeout = 60000;
			while (m_ref) {
				MSG msg;
				GetMessage(&msg, NULL, 0,  0);
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				Sleep(1);
				if (--lockSessionTimeout == 0) {
					MessageBoxA(NULL, "lock wait is timeout ... program deadlock ?", "Error", MB_OK);
				}

			}
			this->lock();
		}
	}
	void unlock()
	{
		if (m_ref == 0) {
			MessageBoxA(NULL, "UnLock Error", "Error", MB_OK);
			return;
		}
		m_ref--;
	}

	bool isLocked()
	{
		return m_ref ? true : false;
	}
};

extern VSTProcessingWait g_processingLock;

class VSTProcessingWaitLocker
{
private:
	VSTProcessingWait &m_lock;
public:
	explicit VSTProcessingWaitLocker(VSTProcessingWait &p) : m_lock(p)
	{
		m_lock.lock();
	}

	virtual ~VSTProcessingWaitLocker()
	{
		m_lock.unlock();
	}
};

