#pragma once

extern void checkEffectProperties (AEffect* effect);
extern void checkEffectProcessing (AEffect* effect);
extern bool checkEffectEditor (AEffect* effect); // minieditor.cpp

typedef AEffect* (*PluginEntryProc) (audioMasterCallback audioMaster);
VstIntPtr VSTCALLBACK HostCallback (AEffect* effect, VstInt32 opcode, VstInt32 index, VstIntPtr value, void* ptr, float opt);


//-------------------------------------------------------------------------------------------------------
// PluginLoader
//-------------------------------------------------------------------------------------------------------
struct PluginLoader
{
//-------------------------------------------------------------------------------------------------------
	HMODULE module;

	explicit PluginLoader () : 
	module(NULL)
	{
	
	}

	~PluginLoader ()
	{

	}

	void freeLibrary()
	{
		if (module) {
			FreeLibrary(module);
			module = NULL;
		}
	}

	bool loadLibrary(const char* fileName)
	{
		module = LoadLibrary(fileName);
		return module != 0;
	}

	PluginEntryProc getMainEntry()
	{
		PluginEntryProc mainProc = 0;
		mainProc = (PluginEntryProc)GetProcAddress(module, "VSTPluginMain");
		if (!mainProc)
			mainProc = (PluginEntryProc)GetProcAddress(module, "main");
		return mainProc;
	}
//-------------------------------------------------------------------------------------------------------
};

struct PluginData
{
	explicit PluginData() : 
	bChannelVstMode(false),
	loader(),
	mainEntry(NULL),
	effect(NULL),
	hwnd(NULL), 
	bProsessing(false),
	bShow(false),
	bSystemEnd(false),
	bClearVstBuffer(false),
	bSampleRateInitYes(false)
	{

	}

	bool bChannelVstMode;

	PluginLoader loader;
	PluginEntryProc mainEntry;
	AEffect *effect;
	HWND hwnd;
	bool bProsessing;
	bool bShow;
	bool bSystemEnd;
	bool bClearVstBuffer;
	bool bSampleRateInitYes; // sample rate Ă邩ǂ yes=1
	int index; // index

	~PluginData()
	{

	}

	void clear()
	{
		bProsessing = false;
		bSystemEnd = false;
		bShow = false;
		bClearVstBuffer = false;
		bSampleRateInitYes = false;

		loader.freeLibrary();

		hwnd = NULL;
		effect = NULL;
		mainEntry = NULL;
	}

	void effClose()
	{
		if(effect){
			effect->dispatcher(effect,AEffectOpcodes::effClose, 0,0,0,0);
			effect = NULL;
		}
	}
};

extern int g_MaxChannelVstCount;
struct tagChannelVstItem
{

	tagChannelVstItem() : 
	pd()
	{
		*reinterpret_cast<unsigned long *>(name) = 0;
	}
	TCHAR name[64];
	PluginData pd;
	WORD ID_VSTInsertBtn;
	WORD ID_VSTInsertBtn_VstLoad;
	unsigned long chMask;
} ;

extern tagChannelVstItem *ChannelVstItem;

extern std::vector<PluginData> ChannelPluginList;